


qeVersionNum = "1.2.4"
QEProfile = ""

local function GetItemSplit(itemLink)
  local itemString = string.match(itemLink, "item:([%-?%d:]+)")
  local itemSplit = {}

  -- Split data into a table
  for _, v in ipairs({strsplit(":", itemString)}) do
    if v == "" then
      itemSplit[#itemSplit + 1] = 0
    else
      itemSplit[#itemSplit + 1] = tonumber(v)
    end
  end

  return itemSplit
end

function scanGear() 
	QEProfile = "" -- Reset text.
	
	slotNames = {
	'head', -- [1]
	'neck', -- [2]
	'shoulder', -- [3]
	'shirt', -- [6]
	'chest', -- [5]
	'waist', -- [10]
	'legs', -- [11]
	'feet', -- [12]
	'wrist', -- [8]
	'hands', -- [9]
	'finger1', -- [13]
	'finger2', -- [14]
	'trinket1', -- [15]
	'trinket2', -- [16]
	'back', -- [4]
	'main_hand', -- [17]
	'off_hand', -- [18]
	'relic', -- [18]
	
	'tabard', -- [7]
	'ammo', -- [19]
	'shield' -- [20]
	}
	
	
	pname = GetUnitName("player")
	_, pclass, _ = 	UnitClass("player")
	pclass = string.lower(pclass)

	addPrint("QE Live Gear Importer v" .. qeVersionNum)
	addPrint("questionablyepic.com/live - Addon based heavily on SimulationCraft")
	addPrint(" ")
	addPrint(pclass .. '="' .. pname .. '"')
	addPrint("level=" .. UnitLevel("player"))
	addPrint("race=" .. UnitRace("player"))
	addPrint("region=")
	addPrint("server=" .. GetRealmName())
	addPrint("role=N/A")
	addPrint("professions=N/A")
	addPrint("talents=N/A")
	addPrint("spec=N/A")
	addPrint(" ")
	
	-- for loop for equipment
	
	for i=1, 19, 1  do
		local equipID = GetInventoryItemID("player", i);
		local itemLink = GetInventoryItemLink('player', i)

		--print(equipID)
		
		if (equipID ~= nil) then
			local itemSplit = GetItemSplit(itemLink)
			local suffix = itemSplit[7] * -1
			if (suffix ~= -0) then
				local unique = bit.band(itemSplit[8], 65535)
				suffix = ",suffix=" .. suffix .. ",unique=" .. unique
			else suffix = "" end
		
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, vendorPrice = GetItemInfo(equipID);
				
			if (itemType == "Weapon" or itemType == "Armor") then
				addPrint(slotNames[i] .. "=,id=" .. equipID .. suffix)
				--print(itemName .. "(" .. itemType .. ")");
					
			end
		end
	
	end
	
	addPrint(" ")
	addPrint("### GEAR FROM BAGS")
	
	for bag=0, NUM_BAG_SLOTS do	
		
		for bagSlots=1, GetContainerNumSlots(bag) do
			--print("Inside the bag this time");
			local itemID = GetContainerItemID(bag, bagSlots);
			
			if (itemID) then 
				local itemName, _, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, vendorPrice = GetItemInfo(itemID);
				
				local itemLink = GetContainerItemLink(bag, bagSlots)
				local itemSplit = GetItemSplit(itemLink)
				local suffix = itemSplit[7] * -1
				
				if (suffix ~= -0) then
					local unique = bit.band(itemSplit[8], 65535)
					suffix = ",suffix=" .. suffix .. ",unique=" .. unique
				else suffix = "" end
				
				
				if ((itemType == "Weapon" or itemType == "Armor") and checkIfUsable(itemType, itemSubType)) then
					addPrint("#")
					addPrint("# " .. itemName)
					addPrint("# " .. convertSlot(itemEquipLoc) .. "=,id=" .. itemID .. suffix)
					--print(itemName .. "(" .. itemType .. ")");
					
				end
			end
						
			--local _, _, itemRarity, _, _, itemType, itemSubType, _, _, _, _ = GetItemInfo()
		end
		
	end
	
	-- show the appropriate frames
	
	--SimcCopyFrame:Show()
	--SimcCopyFrameScroll:Show()
	--SimcCopyFrameScrollText:Show()
	--SimcCopyFrameScrollText:SetText(QEProfile)
	--SimcCopyFrameScrollText:HighlightText()
	--SimcCopyFrameScrollText:SetScript("OnEscapePressed", function(self)
    --SimcCopyFrame:Hide()
  --end)
	--SimcCopyFrameButton:SetScript("OnClick", function(self)
    --SimcCopyFrame:Hide()
  --end)
  
  local f = GetMainFrame(QEProfile)
  f:Show()

end


function GetMainFrame(text)
  -- Frame code largely adapted from https://www.wowinterface.com/forums/showpost.php?p=323901&postcount=2
  if not SimcFrame then
    -- Main Frame
    frameConfig = {
        point = "CENTER",
        relativeFrame = nil,
        relativePoint = "CENTER",
        ofsx = 0,
        ofsy = 0,
        width = 750,
        height = 400,
     }
    local f = CreateFrame("Frame", "SimcFrame", UIParent, "DialogBoxFrame")
    f:ClearAllPoints()
    -- load position from local DB
    f:SetPoint(
      frameConfig.point,
      frameConfig.relativeFrame,
      frameConfig.relativePoint,
      frameConfig.ofsx,
      frameConfig.ofsy
    )
    f:SetSize(frameConfig.width, frameConfig.height)
    f:SetBackdrop({
      bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
      edgeFile = "Interface\\PVPFrame\\UI-Character-PVP-Highlight",
      edgeSize = 16,
      insets = { left = 8, right = 8, top = 8, bottom = 8 },
    })
    f:SetMovable(true)
    f:SetClampedToScreen(true)
    f:SetScript("OnMouseDown", function(self, button)
      if button == "LeftButton" then
        self:StartMoving()
      end
    end)
    f:SetScript("OnMouseUp", function(self, button)
      self:StopMovingOrSizing()
      -- save position between sessions
      point, relativeFrame, relativeTo, ofsx, ofsy = self:GetPoint()
      frameConfig.point = point
      frameConfig.relativeFrame = relativeFrame
      frameConfig.relativePoint = relativeTo
      frameConfig.ofsx = ofsx
      frameConfig.ofsy = ofsy
    end)

    -- scroll frame
    local sf = CreateFrame("ScrollFrame", "SimcScrollFrame", f, "UIPanelScrollFrameTemplate")
    sf:SetPoint("LEFT", 16, 0)
    sf:SetPoint("RIGHT", -32, 0)
    sf:SetPoint("TOP", 0, -32)
    sf:SetPoint("BOTTOM", SimcFrameButton, "TOP", 0, 0)

    -- edit box
    local eb = CreateFrame("EditBox", "SimcEditBox", SimcScrollFrame)
    eb:SetSize(sf:GetSize())
    eb:SetMultiLine(true)
    eb:SetAutoFocus(true)
    eb:SetFontObject("ChatFontNormal")
    eb:SetScript("OnEscapePressed", function() f:Hide() end)
    sf:SetScrollChild(eb)

    -- resizing
    f:SetResizable(true)
    f:SetMinResize(150, 100)
    local rb = CreateFrame("Button", "SimcResizeButton", f)
    rb:SetPoint("BOTTOMRIGHT", -6, 7)
    rb:SetSize(16, 16)

    rb:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
    rb:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
    rb:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")

    rb:SetScript("OnMouseDown", function(self, button)
        if button == "LeftButton" then
            f:StartSizing("BOTTOMRIGHT")
            self:GetHighlightTexture():Hide() -- more noticeable
        end
    end)
    rb:SetScript("OnMouseUp", function(self, button)
        f:StopMovingOrSizing()
        self:GetHighlightTexture():Show()
        eb:SetWidth(sf:GetWidth())

        -- save size between sessions
        frameConfig.width = f:GetWidth()
        frameConfig.height = f:GetHeight()
    end)

    SimcFrame = f
  end
  SimcEditBox:SetText(text)
  SimcEditBox:HighlightText()
  return SimcFrame
end

function addPrint(line)
	--print(line)
	QEProfile = QEProfile .. line .. "\n";
end

function convertSlot(raw)
	if (raw == "INVTYPE_HEAD") then return "head"
	elseif (raw == "INVTYPE_NECK") then return "neck" 
	elseif (raw == "INVTYPE_SHOULDER") then return "shoulder" 
	elseif (raw == "INVTYPE_CHEST") then return "chest" 
	elseif (raw == "INVTYPE_WAIST") then return "waist" 
	elseif (raw == "INVTYPE_LEGS") then return "legs" 
	elseif (raw == "INVTYPE_FEET") then return "feet" 
	elseif (raw == "INVTYPE_WRIST") then return "wrist" 
	elseif (raw == "INVTYPE_HAND") then return "hand" 
	elseif (raw == "INVTYPE_FINGER") then return "finger1" 
	elseif (raw == "INVTYPE_CLOAK") then return "back"
	elseif (raw == "INVTYPE_WEAPON") then return "one_hand"
	elseif (raw == "INVTYPE_SHIELD") then return "shield" 
	elseif (raw == "INVTYPE_2HWEAPON") then return "main_hand" 
	elseif (raw == "INVTYPE_WEAPONMAINHAND") then return "main_hand" 
	elseif (raw == "INVTYPE_WEAPONOFFHAND") then return "off_hand"
	elseif (raw == "INVTYPE_TRINKET") then return "trinket1" 
	elseif (raw == "INVTYPE_RELIC") then return "relic" 
	else return "unknown" end
end

function checkIfUsable(itemType, subType) 
	pclass = UnitClass("player")
	
	armorTypes = {
		["Cloth"] = 1,
		["Leather"] = 2,
		["Mail"] = 3,
		["Plate"] = 4,
		["Shields"] = 3,
		["Librams"] = 0,
		["Totems"] = 0,
		["Idols"] = 0,
		["Miscellaneous"] = 0
		}
		
	classArmor = {
		["Priest"] = 1,
		["Mage"] = 1,
		["Warlock"] = 1,
		["Rogue"] = 2,
		["Druid"] = 2,
		["Shaman"] = 3,
		["Hunter"] = 3,
		["Paladin"] = 4,
		["Warrior"] = 4
	}
	
	classWeps = {
		["Rogue"] = "OneHanded Axes, OneHanded Daggers, OneHanded Maces",
		["Druid"] = "OneHanded Maces, TwoHanded Maces, Staves, Fist Weapons, OneHanded Dagger",
		["Paladin"] = "OneHanded Maces, TwoHanded Maces, OneHanded Axes, TwoHanded Axes, OneHandedSwords, TwoHandedSwords, Polearms",
		["Priest"] = "OneHanded Maces, OneHanded Daggers, Staves",
		["Mage"] = "OneHanded Dagger, OneHanded Sword, Staves, Wands",
		["Warlock"] = "",
		["Shaman"] = "",
		["Hunter"] = "",
		["Warrior"] = ""
	}
		
		
	--print(itemType .. "/" .. pclass .. "/" .. armorTypes[subType] .. "/" .. classArmor[pclass]) 
	--print(itemType)
	--print(subType)
	--print(armorTypes[subType])
	
	if (itemType == "Armor") then
	
		armorType = armorTypes[subType]
		classType = classArmor[pclass]
		
		return classType >= armorType
		
	elseif (itemType == "Weapon") then
	
		stype = subType:gsub('%-', '')
		--print(string.find(classWeps[pclass], stype))
	
		return string.find(classWeps[pclass], stype)
	
	end
	
	

end


SLASH_QE1 = "/qe";
SlashCmdList["QE"] = scanGear;
